program lst2dat;

uses crt,dos,sysutils;

TYPE lstrec =  RECORD
                 dirpath : array[1..30] of char;
                 dskpath : array[1..30] of char;
                 dirdesc : array[1..35] of char;
                 sorttyp : byte;
               END;

var lst_file : file of lstrec;
    lstline  : lstrec;
    fichier_cfg,fichier_err,fichier_dat : text;
    year,month,day,dow : word;
    daystr,monthstr,yearstr,dateweb,out_name,
    lst_name, lst_picture, lst_ftp, lst_text, lst_link: string;
    strdirpath,strdirdesc : string;
    i, lst_header, lst_border : byte;

FUNCTION Exist( sExp: STRING ): BOOLEAN;
VAR s : TSearchRec;
BEGIN
  FINDFIRST( sExp, AnyFile, s );
  Exist := (DOSError = 0);
END;

BEGIN
  clrscr;
  writeln('LST2DAT v1.08 (18th January 2003)');
  writeln('(c) Emmanuel Roussin');
  writeln('Web     http://www.genesis8bit.com/apcb2htm');
  writeln('Email   roussin@noos.fr');
  writeln('Fidonet 2:320/200');
  writeln;
  writeln('dont forget to modify line 6 of each .DAT which were created');
  writeln;
  getdate(year, month, day, dow);
  str(year,yearstr);
  str(month,monthstr);
  str(day,daystr);
  IF length(monthstr)=1 THEN
    monthstr:='0'+monthstr;
  IF length(daystr)=1 THEN
    daystr:='0'+daystr;
  dateweb:=yearstr+monthstr+daystr;

  {start working}

  if paramstr(1)='' THEN
  BEGIN
    writeln('No parameter on command line, need a CFG file');
    assign(fichier_err,'error.txt');
    append(fichier_err);
    writeln(fichier_err,dateweb,' - no parameter on command line for LST2DAT');
    close(fichier_err);
    halt;
  END;

  IF exist(paramstr(1)) THEN
  BEGIN
    assign(fichier_cfg,paramstr(1));
    reset(fichier_cfg);
    readln(fichier_cfg,lst_name);
    readln(fichier_cfg,lst_picture);
    readln(fichier_cfg,lst_border);
    readln(fichier_cfg,lst_ftp);
    readln(fichier_cfg,lst_text);
    readln(fichier_cfg,lst_link);
    readln(fichier_cfg,lst_header);
    IF exist(lst_name) THEN
    BEGIN
      assign(lst_file,lst_name);
      reset(lst_file,sizeof(lstrec));
      seek(lst_file,0);
    END
    ELSE
    BEGIN
      writeln(lst_name,' doesnt exist, check ',paramstr(1));
      assign(fichier_err,'error.txt');
      append(fichier_err);
      writeln(fichier_err,dateweb,' - ',lst_name,' doesnt exist, check ',paramstr(1));
      close(fichier_err);
      halt;
    END;
  END
  ELSE
  BEGIN
    writeln(paramstr(1),' doesnt exist, check your command line');
    assign(fichier_err,'error.txt');
    append(fichier_err);
    writeln(fichier_err,dateweb,' - ',paramstr(1),' doesnt exist, check your command line');
    close(fichier_err);
    halt;
  END;

  {start creating DAT files}

  i:=1;
  while not eof(lst_file) DO
  BEGIN
    read(lst_file,lstline);
    str(i,out_name);
    assign(fichier_dat,out_name+'.dat');
    rewrite(fichier_dat);

    {trimming right spaces}

    strdirpath:=lstline.dirpath;
    strdirpath:=trimright(strdirpath);
    strdirdesc:=lstline.dirdesc;
    strdirdesc:=trimright(strdirdesc);

    {creating DAT file}

    writeln(fichier_dat,strdirpath);
    writeln(fichier_dat,strdirdesc);
    writeln(fichier_dat,lst_picture);
    writeln(fichier_dat,lst_border);
    writeln(fichier_dat,out_name+'.htm');
    writeln(fichier_dat,lst_ftp);
    writeln(fichier_dat,lst_text);
    writeln(fichier_dat,lst_link);
    writeln(fichier_dat,lst_header);
    close(fichier_dat);
    i:=i+1;
  END;
  close(lst_file);
END.
